; Proof for the formula that indicates how many moves are required to
; solve the Towers of Hanoi problem: first part (definitions). Taken
; from the ACL2 documentation.
;
; Antonio Garcia Dominguez
(in-package "HANOI")

(defun move (a b)
  (list 'move a 'to b))

(defun hanoi (a b c n)
  (if (zp n)
      nil
    (if (equal n 1)
        (list (move a c))
      (append (hanoi a c b (1- n))
              (cons (move a c)
                    (hanoi b a c (1- n)))))))

(defthm len-append
  (equal (len (append x y))
         (+ (len x) (len y))))
